#include "huc.h"
#include "scroll22.h"

#incbin(map,"map.fmp")

#incchr_ex(tile1_gfx, "tile1.pcx", 0, 0, 2, 2, 1,\
                      "tile2.pcx", 0, 0, 2, 2, 2)
#incpal(tile1_pal, "tile1.pcx");
#incpal(tile2_pal, "tile2.pcx");

#define  BAT_L 64
#define  BAT_H 32

#define  MAP_L 256
#define  MAP_H 256

const int pal_ref[8]={1,1,1,1,2,2,2,2};

int scrollx_inc, scrollx_a, scrollx_b, x_map;
int scrolly_inc, scrolly_a, scrolly_b, y_map;

main ()
{
int i;

set_xres(320);
set_map_data(map, 256, 256);
set_tile_data(tile1_gfx);
load_tile(0x1000);
set_bgpal(1, tile1_pal);
set_bgpal(2, tile2_pal);
for (i=0; i<41;i++)
  load_map(i,0,i,0,1,29);

for (;;)
{

if (DROITE) scrollx_inc=1;
else
if (GAUCHE) scrollx_inc=-1;
else scrollx_inc=0;

if (HAUT) scrolly_inc=-1;
else
if (BAS) scrolly_inc=1;
else scrolly_inc=0;

/* Scroll selon X */

scrollx_b=scrollx_a+scrollx_inc;

if ( (scrollx_a & 0xFFF8) != (scrollx_b & 0xFFF8) )
   {
   
   if (scrollx_inc>0)
      {
						++x_map;
      load_map((x_map+40)&63, (y_map)&31, ((scrollx_b>>3)+40)&255, ((scrolly_b>>3))&255, 1,29);
	     }
   if (scrollx_inc<0)
						{
						--x_map;
      load_map((x_map)&63, (y_map)&31, ((scrollx_b>>3))&255, ((scrolly_b>>3))&255, 1, 29);
	     }
   }
scrollx_a=scrollx_b;

/* Scroll selon Y */

scrolly_b=scrolly_a+scrolly_inc;

if ( (scrolly_a & 0xFFF8) != (scrolly_b & 0xFFF8) )
   {
   
   if (scrolly_inc>0)
      {
						++y_map;
      load_map((x_map)&63,(y_map+28)&31, ((scrollx_b>>3))&255, ((scrolly_b>>3)+28)&255, 41,1);
	     }
   if (scrolly_inc<0)
						{
						--y_map;
      load_map((x_map)&63,(y_map)&31, ((scrollx_b>>3))&255, ((scrolly_b>>3))&255, 41,1);
	     }
   }
scrolly_a=scrolly_b;



scroll(0, scrollx_a, scrolly_a, 0,255, 0xC0);

vsync();
}

}
